<?php
require("SSI.php");
include("XMLout.php");
/**********************************************************************************
* xssi.php                                                                        *
***********************************************************************************
* XSSI: Simple Machines SSI.php XML Connector                                     *
* =============================================================================== *
* Software Version:           XSSI 1.0                                            *
* Software by:                Don Bauer - dgbauer@bauerbox.com                    *
* License:                    GPL 2.0                                             *
**********************************************************************************/

//start output buffering
ob_start();

$xssi = &new XMLout;

// Begin Action Logic
if (isset($_GET['a'])) {
	switch ($_GET['a']) {
		case "recentTopics":
			if (isset($_GET['num_recent']))
			{
				$num_recent = intval($_GET['num_recent']);
			} else {
				$num_recent = 8;
			}
			if(isset($num_recent) && $num_recent < 1)
			{
				$num_recent = 8;
			}
			if (isset($_GET['exclude_boards']))
			{
				$exclude_boards = intval($_GET['exclude_boards']);
			} else {
				$exclude_boards = null;
			}
			if(isset($num_recent) && $num_recent < 1)
			{
				$exclude_boards = null;
			}
			$return = $xssi->arrayToXML(ssi_recentTopics($num_recent, $exclude_boards, 'array'));
			break;
		case "recentPosts":
			if (isset($_GET['num_recent']))
			{
				$num_recent = intval($_GET['num_recent']);
			} else {
				$num_recent = 8;
			}
			if(isset($num_recent) && $num_recent < 1)
			{
				$num_recent = 8;
			}
			if (isset($_GET['exclude_boards']))
			{
				$exclude_boards = intval($_GET['exclude_boards']);
			} else {
				$exclude_boards = null;
			}
			if(isset($num_recent) && $num_recent < 1)
			{
				$exclude_boards = null;
			}
			$return = $xssi->arrayToXML(ssi_recentPosts($num_recent, $exclude_boards, 'array'));
			break;
		case "topPoster":
			if(isset($_GET['topNumber']))
			{
				$topNumber = intval($_GET['topNumber']);
			} else {
				$topNumber = 1;
			}
			if ($topNumber < 1) $topNumber = 1;
			$return = $xssi->arrayToXML(ssi_topPoster($topNumber,'array'));
			break;
		case "topTopics":
			if(isset($_GET['num_topics']))
			{
				$num_topics = intval($_GET['num_topics']);
			} else {
				$num_topics = 10;
			}
			if ($num_topics < 1) $num_topics = 10;
			if(isset($_GET['type']))
			{
				$type = $_GET['type'];
			} else {
				$type = 'replies';
			}
			$return = $xssi->arrayToXML(ssi_topTopics($type = 'replies', $num_topics, 'array'));
			break;
		case "topTopicsReplies":
			if(isset($_GET['num_topics']))
			{
				$num_topics = intval($_GET['num_topics']);
			} else {
				$num_topics = 10;
			}
			if ($num_topics < 1) $num_topics = 10;
			$return = $xssi->arrayToXML(ssi_topTopics($type = 'replies', $num_topics, 'array'));
			break;
		case "topTopicsViews":
			if(isset($_GET['num_topics']))
			{
				$num_topics = intval($_GET['num_topics']);
			} else {
				$num_topics = 10;
			}
			if ($num_topics < 1) $num_topics = 10;
			$return = $xssi->arrayToXML(ssi_topTopics($type = 'views', $num_topics, 'array'));
			break;
		case "latestMember":
			$return = $xssi->arrayToXML(ssi_latestMember('array'));
			break;
		case "welcome":
			$return = $xssi->arrayToXML(ssi_welcome('array'));
			break;
		case "whosOnline":
			$return = $xssi->arrayToXML(ssi_whosOnline('array'));
			break;
		case "logOnline":
			$return = $xssi->arrayToXML(ssi_logOnline('array'));
			break;
		case "quickSearch":
			$return = $xssi->arrayToXML(ssi_quickSearch('array'),"quickSearch");
			break;
		case "news":
			$return = $xssi->arrayToXML(ssi_news('array'),"news");
			break;
		case "todaysBirthdays":
			$return = $xssi->arrayToXML(ssi_todaysBirthdays('array'));
			break;
		case "todaysHolidays":
			$return = $xssi->arrayToXML(ssi_todaysHolidays('array'));
			break;
		case "todaysEvents":
			$return = $xssi->arrayToXML(ssi_todaysEvents('array'));
			break;
		case "todaysCalendar":
			$return = $xssi->arrayToXML(ssi_todaysCalendar('array'));
			break;
		case "recentEvents":
			if(isset($_GET['max_events']))
			{
				$max_events = intval($_GET['max_events']);
			} else {
				$max_events = 7;
			}
			if ($max_events < 1) $max_events = 7;
			$return = $xssi->arrayToXML(ssi_recentEvents($max_events = 7,'array'));
			break;
		case "logout":
			if (isset($_GET['r']))
			{
				$return = $xssi->arrayToXML(ssi_logout($_GET['r'],'array'));
			} else {
				$return = $xssi->arrayToXML(ssi_logout(null,'array'),"logout");
			}
			break;
		case "login":
			if (isset($_GET['r']))
			{
				$return = $xssi->arrayToXML(ssi_login($_GET['r'],'array'));
			} else {
				$return = $xssi->arrayToXML(ssi_login(null,'array'),"login");
			}
			break;
		case "boardStats":
			$return = $xssi->arrayToXML(ssi_boardStats('array'));
			break;
		case "topBoards":
			if (isset($_GET['num_top']))
			{
				$num_top = intval($_GET['num_top']);
				if ($num_top < 1)
				{
					$num_top = 10;
				}
			} else {
				$num_top = 10;
			}
			$return = $xssi->arrayToXML(ssi_topBoards($num_top, 'array'));
			break;
		case "boardNews":
			if (isset($_GET['board']))
			{
				$board = intval($_GET['board']);
			} else {
				$board = null;
			}
			if (isset($_GET['limit']))
			{
				$limit = intval($_GET['limit']);
			} else {
				$limit = null;
			}
			if (isset($_GET['start']))
			{
				$start = intval($_GET['start']);
			} else {
				$start = null;
			}
			if (isset($_GET['length']))
			{
				$length = intval($_GET['length']);
			} else {
				$length = null;
			}
			$return = $xssi->arrayToXML(ssi_boardNews($board, $limit, $start, $length, 'array'));
			break;
		default:
			$return = $xssi->error("The action:'".$_GET['a']."' has not been implemented yet.");
			break;
	} 
} else {
	$return = $xssi->error("The connector was called incorrectly");
}
header('Content-type: text/xml');
print $return;
ob_end_flush();
?>